#TEMPLATE (SqlMaint, 'Sql Maint'), FAMILY('ABC'), FAMILY('CW20')
#procedure(SqlDatabaseMaint, 'Sql Database Maint')
#prompt('File owner:', @s80), %Fowner
#prompt('Non-ABC app', check), %NonABCapp
#atstart
#endat
#declare(%expr)
%procedure  procedure()
#prototype('()')
!   SQLMaint template
!   Copyright 2006 Dan Pressnell
!   Feel free to make any changes you want, but if you distribute your
!   changes, include some notes describing them.
!   Free to use and distribute without restriction, except you must
!   keep the original copyright notice.

  map
    UpgradeFile(*file pFile), long, proc
    ShowLogQueue()
    DoNotCreate(*file pFile)
  end

dbtype    string(20)  ! supported types now... SQLSERVER, ACCESS, (let me know about others that don't work with this, please)

q             queue
TableName     cstring(61)
FieldLabel    cstring(61)
fieldname     cstring(61)
FieldType     cstring(61)
FieldSize     long
FieldPlaces   long
CreateType    cstring(61)
IsIdentity    byte
      end

sqlQ      queue
SQL         cstring(150)
          end

NoCreateQueue   queue
FileRef         long
                end

IdentityQueue   queue
FieldLabel      cstring(61)
                end

qWindow WINDOW('Actions performed'),AT(,,288,196),CENTER,SYSTEM,GRAY,MAX,RESIZE
       BUTTON('Script to Clipboard'),AT(7,3,76,14),USE(?scriptbutton)
       SHEET,AT(0,19),USE(?Sheet1),FULL
         TAB('Structures'),USE(?Tab1)
           LIST,AT(0,38),USE(?List),FULL,VSCROLL,FORMAT('67L(2)|M67L(2)|M67L(2)|M67L(2)|M65L(2)|M56L(2)|M63L(2)|M89L(2)|M'), |
               FROM(q)
         END
         TAB('SQL sent'),USE(?Tab2)
           LIST,AT(0,36),USE(?sqllist),FULL,VSCROLL,FORMAT('20L(4)|M'),FROM(sqlq)
         END
       END
     END

#embed(%DataSection, 'Data Section for upgrading all files'), noindent

  CODE
  #embed(%BeforeManage, 'Before managing files')
  #if(%NonABCApp = 0)
  do SetIdentityFields
  do UnregisterCallbacks
  #embed(%AfterCallbacksRemoved, 'After Callbacks Removed')
  #endif
  do UpgradeFiles
  #if(%NonABCApp = 0)
  #embed(%BeforeCallbacksRestored, 'Before Callbacks Restored')
  do ReRegisterCallbacks
  #endif
  #embed(%AfterManage, 'After managing files')

UpgradeFiles   routine
  #embed(%BeforeUpgradeFiles, 'Before UpgradeFiles')
  #for(%File)
    #if(upper(%FileOwner) = upper(%FOwner) and %FOwner <> '')
  UpgradeFile(%File)
    #endif
  #endfor
  #embed(%AfterUpgradeFiles, 'After UpgradeFiles')

SetIdentityFields   routine
  #for(%File)
    #for(%Field)
      #IF((EXTRACT(UPPER(%FieldUserOptions), UPPER('IsIdentity'),1) = '1' OR UPPER(EXTRACT(UPPER(%FieldUserOptions), UPPER('IsIdentity'),1)) = 'TRUE') OR EXTRACT(UPPER(%FieldUserOptions), UPPER('ServerAutoIncColumn'),1) <> '')
        #set(%Expr, 'IdentityQueue.FieldLabel = ''' & upper(%Field) & '''')
  %Expr
  add(IdentityQueue)
      #endif
    #endfor
  #endfor

  #if(%NonABCApp = 0)
UnregisterCallbacks   routine
  ! remove callback registration for files because OPEN and CLOSE will be used,
  ! and debug mode will cause needless assertions
  #for(%File)
    #if(upper(%FileOwner) = upper(%FOwner) and %FOwner <> '')
  callback(%File, Access:%File.FileCallbackInterface, 1)
    #endif
  #endfor
  #endif

  #if(%NonABCApp = 0)
ReRegisterCallbacks   routine
  ! put back callback registrations that were removed earlier
  #for(%File)
    #if(upper(%FileOwner) = upper(%FOwner) and %FOwner <> '')
  callback(%File, Access:%File.FileCallbackInterface) 
    #endif
  #endfor
  #endif

#embed(%ProcedureRoutines, 'Procedure Routines, etc.')
#!
#!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

UpgradeFile  procedure(*File pFile) !, long, proc


workfile  &file
buf &group


groupsize   long(0)
i           long
er          byte
rv          byte
dbo         cstring(10)
connstring  cstring(255)
inDateTime  long
vSQL        any
firstfield  byte
Quotable    byte

#embed(%DataSection2, 'Data Section for upgrading one file'), noindent
  CODE
  rv = 0
  NoCreateQueue.FileRef = address(pfile)
  get(NoCreateQueue, NoCreateQueue.FileRef)
  if errorcode() = 0
    return rv
  end
  workfile &= pfile
  workfile{prop:logonscreen} = 0
  if workfile{prop:sqldriver} = 0
    return rv
  end
  if instring('MICROSOFT ACCESS', upper(workfile{prop:owner}), 1,1)
    dbtype = 'ACCESS'
  end
  if instring('SQL SERVER', upper(workfile{prop:owner}), 1,1) |
      or instring('SQL NATIVE CLIENT', upper(workfile{prop:owner}), 1, 1) |
      or workfile{prop:driver} = 'MSSQL'
    dbtype = 'SQLSERVER'
    if instring('.', pfile{prop:name}, 1, 1) = 0
      dbo = 'dbo.'
    end
  end
  #embed(%BeforeOpeningWorkfile, 'Before opening workfile')
  open(workfile)
  if errorcode() = 90
    message(error() & '<13,10,13,10>' & fileerror())
    halt()
  end
  #embed(%Afteropeningfile, 'After opening file')
  do createit
  #embed(%BeforeReturning, 'Before returning from procedure')
  open(workfile)  ! open one more time to prevent "not open" issue in callback interface once restored (gets rid of current ERRORCODE())
  close(workfile)
  return rv

createit  routine
  do createfields
  do CreateIndexes

CreateFields    routine
  !free(q)
  buf &= workfile{prop:record}
  loop i=1 to workfile{prop:fields}
    Quotable = 0
    if indatetime > 0
      indatetime -= 1
      cycle
    end
    q.fieldname = workfile{prop:name, i}
    q.tablename = dbo & workfile{prop:name}
    if q.fieldname = ''
      q.fieldname = workfile{prop:label, i}
      p# = instring(':', q.fieldname)
      if p# > 0
        q.fieldname = sub(q.fieldname, p# + 1, len(q.fieldname) - p#)
      end
    end
    p# = instring('|', q.fieldname, 1, 1)  ! handle special driver strings for fields
    if p# > 0
      q.fieldname = sub(q.fieldname, 1, p# - 1)
    end
    q.fieldtype = workfile{prop:type, i}
    if q.fieldtype = 'GROUP'
      cycle
    end
    q.fieldsize = workfile{prop:size, i}
    q.fieldplaces = workfile{prop:places, i}
    case q.fieldtype
    of 'STRING'
      q.createtype = 'varchar(' & q.fieldsize & ')'
      Quotable = 1
      if q.fieldsize = 8 and workfile{prop:type, i + 1} = 'GROUP' and |
            workfile{prop:type, i + 2} = 'DATE' AND workfile{prop:type, i + 3} = 'TIME' and |
            workfile{prop:over, i + 1} = i
        indatetime = 3
        q.createtype = 'datetime'
      end
    OF 'CSTRING' OROF 'PSTRING'
      q.createtype = 'varchar(' & q.fieldsize - 1 & ')'
      Quotable = 1
    OF 'BYTE'
      q.createtype = 'tinyint'
      if dbtype = 'ACCESS'
        q.createtype = 'byte'
      end
    OF 'LONG' OROF 'SHORT'
      q.createtype = 'int'
    OF 'REAL'
      q.createtype = 'float'
    OF 'DECIMAL' OROF 'PDECIMAL'
      q.createtype = 'decimal(' & q.fieldsize * 2 & ',' & q.fieldplaces & ')'
      if dbtype = 'ACCESS'
        q.createtype = 'currency'
      end
    OF 'DATE'
      q.createtype = 'datetime'
    END
    if q.fieldsize > 255 or q.fieldtype = 'BLOB'
      q.createtype = 'text'
      if dbtype = 'ACCESS'
        q.createtype = 'memo'
      end
      Quotable = 1
    end
    q.fieldlabel = workfile{prop:label, i}
    IdentityQueue.FieldLabel = q.fieldlabel
    get(IdentityQueue, IdentityQueue.FieldLabel)
    if errorcode() = 0
      q.IsIdentity = 1
      if dbtype = 'ACCESS'
        q.createtype = ' autoincrement' ! no type such as "int autoincrement", this IS the type
      else
        q.createtype = clip(q.createtype) & ' identity'
      end
    else
      q.IsIdentity = 0
    end
    if i=1
      do CreateTable
    end
    if i=1
      firstfield = 1
    else
      firstfield = 0
    end
    do createfield
    add(q)
  end
! do showit

showit    routine
  ShowLogQueue()

createfield   routine
  data
vv      any
Created byte
  code
  vsql = 'alter table ' & workfile{prop:name} & ' add ' & q.fieldname & ' ' & q.createtype
  do SendSQL
  if errorcode() = 0
    Created = 1
  else
    Created = 0
  end
  if quotable
    vsql = 'update ' & workfile{prop:name} & ' set ' & q.fieldname & ' = '''' where ' & q.fieldname & ' is null'
    if dbtype = 'ACCESS'
      vsql = 'update ' & workfile{prop:name} & ' set ' & q.fieldname & ' = '' '' where ' & q.fieldname & ' is null'
    end
  else
    vsql = 'update ' & workfile{prop:name} & ' set ' & q.fieldname & ' = 0 where ' & q.fieldname & ' is null'
  end
  #embed(%AfterCreatingOneField, 'After Creating One Field')
  case upper(q.fieldlabel)
  #embed(%InsideFieldCase, 'Inside "case FieldLabel"')
  end



createtable   routine
  vsql = 'create table ' & dbo & workfile{prop:name} & ' (' & q.fieldname & ' ' & q.createtype & ')'
  do sendsql
  if errorcode() <> 90
    rv = 1
  else
  end

CreateIndexes   routine
  data
kref  &key
nam   cstring(51)
flds  any
  code
    loop i=1 to workfile{prop:keys}
      kref &= workfile{prop:key, i}
      nam = kref{prop:name}
      if nam = ''
        nam = kref{prop:label}
      end
      p# = instring(':', nam, 1,1)
      if p# > 0
        nam = sub(nam, p# + 1, len(nam) - p#)
      end
      p# = instring('.', nam, 1,1)
      if p# > 0
        nam = sub(nam, p# + 1, len(nam) - p#)
      end
      if kref{prop:primary}
        flds = 'create unique index ' & nam & ' on ' & workfile{prop:name} & ' ('
      elsif kref{prop:dup}
        flds = 'create index ' & nam & ' on ' & workfile{prop:name} & ' ('
      else
        flds = 'create unique index ' & nam & ' on ' & workfile{prop:name} & ' ('
      end
      loop jj#=1 to kref{prop:components}
        n# = kref{prop:field, jj#}
        nam = workfile{prop:name, n#}
        if nam = ''
          nam = workfile{prop:label, n#}
        end
        p# = instring(':', nam, 1,1)
        if p# > 0
          nam = sub(nam, p# + 1, len(nam) - p#)
        end
        p# = instring('|', nam, 1, 1)
        if p# > 0
          nam = sub(nam, 1, p# - 1)
        end
        if jj# > 1
          flds = flds & ','
        end
        flds = flds & nam
        if kref{prop:ascending, jj#} = 0
          flds = flds & ' desc'
        end
      end
      flds = flds & ')'
      vsql = flds
      do sendsql
      if errorcode() <> 90
        rv = 1
      end
      !stop(workfile{prop:sql})
    end

sendsql routine
  #embed(%BeforeSendingSQL, 'Before sending sql to server')
  sqlq.sql = vsql
  add(sqlq)
  workfile{prop:sql} = vsql
  #embed(%AfterSendingSQL, 'After sending sql to server')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

ShowLogQueue    procedure
  code
  open(qwindow)
  loop while 0{prop:xpos} > 1
    0{prop:xpos} = 0{prop:xpos} - 1
    0{prop:width} = 0{prop:width} + 2
  end
  loop while 0{prop:ypos} > 1
    0{prop:ypos} = 0{prop:ypos} - 1
    0{prop:height} = 0{prop:height} + 2
  end
  accept
    case accepted()
    of ?scriptbutton
      do MakeScript
    end
  end
  close(qwindow)

MakeScript    routine
  data
sc  any
  code
  loop i#=1 to records(sqlq)
    get(sqlq, i#)
    sc = sc & sqlq.sql & '<13,10>GO<13,10>'
  end
  setclipboard(sc)
  message('Script is in your Windows clipboard now.')



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

DoNotCreate   procedure(*file pFile)
  code
  NocreateQueue.FileRef = address(pfile)
  add(NocreateQueue)

